/* 
 * Additem.js
 * 
 * Copyright (c) 1997 Netscape Communications Corporation, All Rights Reserved
 * 
 */


/*
 * UpdateTimeFields
 * 
 *  In : a window object which represents the add dialog box
 *
 *  Out: None
 *
 * This function checks the value in the frequency box to see if
 * the user needs additional dialogs to enter their desired time.
 */

function UpdateTimeFields(prefsWindow)
{
	var form			= prefsWindow.document.chnform;
	var newInterval		= form.freq.options[form.freq.selectedIndex].value;
	var specialLayer;

    dbgMsg("Top: " + prefsWindow.document.anchors["timePos"].x);
    dbgMsg("Left: " + prefsWindow.document.anchors["timePos"].y);

	if (newInterval == "-5") {
		// Day view
		prefsWindow.document.layers['weekLayer'].visibility="hide";
		specialLayer = prefsWindow.document.layers['dayLayer'];
        specialLayer.top = prefsWindow.document.anchors["timePos"].y;
        specialLayer.left = prefsWindow.document.anchors["timePos"].x + 10;
		specialLayer.visibility="show";
	} else if (newInterval == "-6") {
		// Week view
		prefsWindow.document.layers['dayLayer'].visibility="hide";
		specialLayer = prefsWindow.document.layers['weekLayer'];
        specialLayer.top = prefsWindow.document.anchors["timePos"].y;
        specialLayer.left = prefsWindow.document.anchors["timePos"].x + 10;
		specialLayer.visibility="show";
	} else {
		// Everything else
		prefsWindow.document.layers['weekLayer'].visibility="hide";
		prefsWindow.document.layers['dayLayer'].visibility="hide";
	}

	return;
}


// Shared by NewChand.htm and NewCastn.htm
function initNewUpdateFreq(prefsWindow, defaultFreq)
{
  var dayForm  = document.layers["dayLayer"].document.times;
  var weekForm = document.layers["weekLayer"].document.times;

  for(i=0; i<document.chnform.freq.length; i++)
  {
    dbgMsg("Freq #"+i +": " + document.chnform.freq[i].value);
    if(document.chnform.freq[i].value == defaultFreq)
      document.chnform.freq[i].selected = true;
  }
  document.chnform.active.checked    = true;

  //Defaults for the Day layer
  for(i=0; i<dayForm.time.length; i++)
  {
    dbgMsg("Freq #"+i +": " + dayForm.time.options[i].value);
    if(dayForm.time.options[i].value == "360")
      dayForm.time.options[i].selected = true;
  }
  for(i=0; i<dayForm.ampm.length; i++)
  {
    dbgMsg("Freq #"+i +": " + dayForm.ampm.options[i].value);
    if(dayForm.ampm.options[i].value == "0")
      dayForm.ampm.options[i].selected = true;
  }

  //Defaults for the Week Layer
  for(i=0; i<weekForm.day.length; i++)
  {
    dbgMsg("Freq #"+i +": " + weekForm.day.options[i].value);
    if(weekForm.day.options[i].value == "1440")
      weekForm.day.options[i].selected = true;
  }
  for(i=0; i<weekForm.time.length; i++)
  {
    dbgMsg("Freq #"+i +": " + weekForm.time.options[i].value);
    if(weekForm.time.options[i].value == "360")
      weekForm.time.options[i].selected = true;
  }
  for(i=0; i<weekForm.ampm.length; i++)
  {
    dbgMsg("Freq #"+i +": " + weekForm.ampm.options[i].value);
    if(weekForm.ampm.options[i].value == "0")
      weekForm.ampm.options[i].selected = true;
  }
}


// Shared by NewChand.htm and NewCastn.htm
function commitNewUpdateFreq(prefsWindow)
{
  var dayForm  = document.layers["dayLayer"].document.times;
  var weekForm = document.layers["weekLayer"].document.times;

  var tDayTime =   parseInt(dayForm.time.options[dayForm.time.selectedIndex].value) 
                 + parseInt(dayForm.ampm.options[dayForm.ampm.selectedIndex].value);
  dbgMsg("Day Total value: " + tDayTime);

  var tWeekTime =   parseInt(weekForm.day.options[weekForm.day.selectedIndex].value) 
                  + parseInt(weekForm.time.options[weekForm.time.selectedIndex].value) 
                  + parseInt(weekForm.ampm.options[weekForm.ampm.selectedIndex].value);
  dbgMsg("Week Total value: " + tWeekTime);

    if(document.chnform.active.checked == false)
      tmpList.update_freq = "-1";
	else
    {
      for(i=0; i<document.chnform.freq.length; i++)
      {
        if(document.chnform.freq[i].selected == true)
          tmpList.update_freq = document.chnform.freq[i].value;
      }
    }
    dbgMsg("Update frequency: "+tmpList.update);
    if(tmpList.update_freq == "-5")
    {
	   tmpList.update_time = ""+tDayTime;
    }
    else
    if(tmpList.update_freq == "-6")
    {
	   tmpList.update_time = ""+tWeekTime;
    }
    else
    {
	   tmpList.update_time = "-1";
    }
}


// Shared by EdtChand.htm and EdtCastn.htm
function initEdtUpdateFreq(prefsWindow)
{
  document.layers["dayLayer"].top = prefsWindow.document.anchors["timePos"].y;
  document.layers["dayLayer"].left = prefsWindow.document.anchors["timePos"].x + 10;
  var dayForm  = document.layers["dayLayer"].document.times;

  document.layers["weekLayer"].top = prefsWindow.document.anchors["timePos"].y;
  document.layers["weekLayer"].left = prefsWindow.document.anchors["timePos"].x + 10;
  var weekForm = document.layers["weekLayer"].document.times;

  var tmpDay;
  var tmpTime;
  var tmpAmPm;
  var i;

  document.chnform.update_freq = editOption.update_freq;
  document.chnform.update_time = editOption.update_time;

  if(editOption.update_freq == "-1")
  {
    document.chnform.active.checked = false;

    for(i=0; i<document.chnform.freq.length; i++)
    {
      dbgMsg("Freq #"+i +": " + document.chnform.freq[i].value);
      if(document.chnform.freq[i].value == "720")
        document.chnform.freq[i].selected = true;
    }
  
    //Defaults for the Day layer
    for(i=0; i<dayForm.time.length; i++)
    {
      dbgMsg("Freq #"+i +": " + dayForm.time.options[i].value);
      if(dayForm.time.options[i].value == "360")
        dayForm.time.options[i].selected = true;
    }
    for(i=0; i<dayForm.ampm.length; i++)
    {
      dbgMsg("Freq #"+i +": " + dayForm.ampm.options[i].value);
      if(dayForm.ampm.options[i].value == "0")
        dayForm.ampm.options[i].selected = true;
    }
  
    //Defaults for the Week Layer
    for(i=0; i<weekForm.day.length; i++)
    {
      dbgMsg("Freq #"+i +": " + weekForm.day.options[i].value);
      if(weekForm.day.options[i].value == "1440")
        weekForm.day.options[i].selected = true;
    }
    for(i=0; i<weekForm.time.length; i++)
    {
      dbgMsg("Freq #"+i +": " + weekForm.time.options[i].value);
      if(weekForm.time.options[i].value == "360")
        weekForm.time.options[i].selected = true;
    }
    for(i=0; i<weekForm.ampm.length; i++)
    {
      dbgMsg("Freq #"+i +": " + weekForm.ampm.options[i].value);
      if(weekForm.ampm.options[i].value == "0")
        weekForm.ampm.options[i].selected = true;
    }
  }
  else  //i.e. editOption.update_freq != "-1"
  {
    document.chnform.active.checked = true;

    for(i=0; i<document.chnform.freq.length; i++)
    {
      if(document.chnform.freq[i].value == editOption.update_freq)
        document.chnform.freq[i].selected = true;
    }

    // Get settings for and display Day Layer
    if(editOption.update_freq == "-5")
    {
      if(parseInt(editOption.update_time) > 719)
      {
        tmpTime = "" + (parseInt(editOption.update_time) - 720);
        tmpAmPm = "720";
      }
      else
      {
        tmpTime = editOption.update_time;
        tmpAmPm = "0";
      }

      for(i=0; i<dayForm.time.length; i++)
      {
        if(dayForm.time.options[i].value == tmpTime)
          dayForm.time.options[i].selected = true;
      }
      for(i=0; i<dayForm.ampm.length; i++)
      {
        if(dayForm.ampm.options[i].value == tmpAmPm)
          dayForm.ampm.options[i].selected = true;
      }

      document.layers["dayLayer"].visibility = "show";
    }

    // Get settings for and display Week Layer
    if(editOption.update_freq == "-6")
    {
      tmpDay = 0;
      while( parseInt(editOption.update_time) - tmpDay > 1439)
      {
        tmpDay = 1440 + tmpDay;
      }

      tmpTime = parseInt(editOption.update_time) - tmpDay;
      tmpDay = "" + tmpDay;

      if(tmpTime > 719)
      {
        tmpTime = "" + (tmpTime - 720);
        tmpAmPm = "720";
      }
      else
      {
        tmpTime = "" + tmpTime;
        tmpAmPm = "0";
      }

      for(i=0; i<weekForm.day.length; i++)
      {
        if(weekForm.day.options[i].value == tmpDay)
          weekForm.day.options[i].selected = true;
      }
      for(i=0; i<weekForm.time.length; i++)
      {
        if(weekForm.time.options[i].value == tmpTime)
          weekForm.time.options[i].selected = true;
      }
      for(i=0; i<weekForm.ampm.length; i++)
      {
        if(weekForm.ampm.options[i].value == tmpAmPm)
          weekForm.ampm.options[i].selected = true;
      }

      document.layers["weekLayer"].visibility = "show";
    }
  }
}

// Shared by EdtChand.htm and EdtCastn.htm
function commitEdtUpdateFreq(prefsWindow)
{
  var dayForm  = document.layers["dayLayer"].document.times;
  var weekForm = document.layers["weekLayer"].document.times;

  var tDayTime =   parseInt(dayForm.time.options[dayForm.time.selectedIndex].value) 
                 + parseInt(dayForm.ampm.options[dayForm.ampm.selectedIndex].value);
  dbgMsg("Day Total value: " + tDayTime);

  var tWeekTime =   parseInt(weekForm.day.options[weekForm.day.selectedIndex].value) 
                  + parseInt(weekForm.time.options[weekForm.time.selectedIndex].value) 
                  + parseInt(weekForm.ampm.options[weekForm.ampm.selectedIndex].value);
  dbgMsg("Week Total value: " + tWeekTime);

  if(document.chnform.active.checked == false)
    editOption.update_freq = "-1";
  else
  {
    for(i=0; i<document.chnform.freq.length; i++)
    {
      if(document.chnform.freq[i].selected == true)
        editOption.update_freq = document.chnform.freq[i].value;
    }
  }
  dbgMsg("Update frequency: "+editOption.update);
  if(editOption.update_freq == "-5")
  {
    editOption.update_time = ""+tDayTime;
  }
  else
  if(editOption.update_freq == "-6")
  {
    editOption.update_time = ""+tWeekTime;
  }
  else
  {
    editOption.update_time = "-1";
  }
}
